#ifndef __GG_SIMPLESHADER_H__
#define __GG_SIMPLESHADER_H__

/*
** PȉAetsVF[_
*/
#include "Gg.h"

namespace gg
{
  // f[^̊i[
  inline void set(GLfloat *p, GLfloat p0, GLfloat p1, GLfloat p2, GLfloat p3)
  {
    p[0] = p0;
    p[1] = p1;
    p[2] = p2;
    p[3] = p3;
  }
  inline void set(GLfloat *p, const GLfloat *q)
  {
    p[0] = q[0];
    p[1] = q[1];
    p[2] = q[2];
    p[3] = q[3];
  }
  
  // 
  class GgSimpleLight
  {
    // p[^
    GLfloat ldiff[4];   // ̊gUˌ
    GLfloat lspec[4];   // ̋ʔˌ
    GLfloat lamb[4];    // ̊
    GLfloat lpos[4];    // ̈ʒu

  public:

    // fXgN^
    virtual ~GgSimpleLight(void) {}

    // RXgN^
    GgSimpleLight(void) {}
 
    // p[^̐ݒ
    void setDiffuse(const GLfloat *diff)
    {
      set(ldiff, diff);
    }
    void setDiffuse(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(ldiff, r, g, b, a);
    }
    void setSpecular(const GLfloat *spec)
    {
      set(lspec, spec);
    }
    void setSpecular(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(lspec, r, g, b, a);
    }
    void setAmbient(const GLfloat *amb)
    {
      set(lamb, amb);
    }
    void setAmbient(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(lamb, r, g, b, a);
    }
    void setPosition(const GLfloat *pos)
    {
      set(lpos, pos);
    }
    void setPosition(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f)
    {
      set(lpos, x, y, z, w);
    }

    // p[^̎擾
    const GLfloat *getDiffuse(void) const
    {
      return ldiff;
    }
    const GLfloat *getSpecular(void) const
    {
      return lspec;
    }
    const GLfloat *getAmbient(void) const
    {
      return lamb;
    }
    const GLfloat *getPosition(void) const
    {
      return lpos;
    }
  };

  // ގ
  class GgSimpleMaterial
  {
    // ގp[^
    GLfloat kdiff[4];   // ގ̊gUˌW
    GLfloat kspec[4];   // ގ̋ʔˌW
    GLfloat kamb[4];    // ގ̊ɑ΂锽ˌW
    GLfloat kshi;       // ގ̋PW

  public:

    // fXgN^
    virtual ~GgSimpleMaterial(void) {}

    // RXgN^
    GgSimpleMaterial(void) {}

    // p[^̐ݒ
    void setDiffuse(const GLfloat *diff)
    {
      set(kdiff, diff);
    }
    void setDiffuse(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(kdiff, r, g, b, a);
    }
    void setSpecular(const GLfloat *spec)
    {
      set(kspec, spec);
    }
    void setSpecular(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(kspec, r, g, b, a);
    }
    void setAmbient(const GLfloat *amb)
    {
      set(kamb, amb);
    }
    void setAmbient(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0f)
    {
      set(kamb, r, g, b, a);
    }
    void setShininess(const GLfloat *shi)
    {
      kshi = *shi;
    }
    void setShininess(GLfloat shi)
    {
      kshi = shi;
    }

    // ގp[^̓Kp
    const GLfloat *getDiffuse(void) const
    {
      return kdiff;
    }
    const GLfloat *getSpecular(void) const
    {
      return kspec;
    }
    const GLfloat *getAmbient(void) const
    {
      return kamb;
    }
    const GLfloat getShininess(void) const
    {
      return kshi;
    }
  };

  // VF[_
  class GgSimpleShader
    : public GgShader
  {
    // attribute ϐ̏ꏊ
    GLint pvLoc;        // ʒu
    GLint nvLoc;        // @

    // ϊs uniform ϐ̏ꏊ
    GLint mwLoc;        // fr[ϊs
    GLint mcLoc;        // fr[eϊs
    GLint mgLoc;        // @ϊs

    // p[^ uniform ϐ̏ꏊ
    GLint ldiffLoc;     // gUˌ
    GLint lspecLoc;     // ʔˌ
    GLint lambLoc;      // 
    GLint lposLoc;      // ʒu

    // ގp[^ uniform ϐ̏ꏊ
    GLint kdiffLoc;     // gUˌW
    GLint kspecLoc;     // ʔˌW
    GLint kambLoc;      // ɑ΂锽ˌW
    GLint kshiLoc;      // PW

  public:

    // fXgN^
    virtual ~GgSimpleShader(void) {}

    // RXgN^
    GgSimpleShader(
      const GLchar *vert  = "GgSimpleShader.vert",
      const GLchar *frag  = "GgSimpleShader.frag",
      const GLchar *pv    = "pv",
      const GLchar *nv    = "nv",
      const GLchar *mw    = "mw",
      const GLchar *mc    = "mc",
      const GLchar *mg    = "mg",
      const GLchar *ldiff = "ldiff",
      const GLchar *lspec = "lspec",
      const GLchar *lamb  = "lamb",
      const GLchar *lpos  = "lpos",
      const GLchar *kdiff = "kdiff",
      const GLchar *kspec = "kspec",
      const GLchar *kamb  = "kamb",
      const GLchar *kshi  = "kshi"
      );
  
    // 
    const GgSimpleLight *light;
    
    // ގ
    const GgSimpleMaterial *material;
    
    // attribute ϐ pv ̏ꏊ𓾂
    GLint getPvLoc(void)
    {
      return pvLoc;
    }
    
    // attribute ϐ nv ̏ꏊ𓾂
    GLint getNvLoc(void)
    {
      return nvLoc;
    }

    // VF[_vO̓Kp
    void use(GgMatrix &projection, GgMatrix &modelview) const;
  };
}

#endif
