#version 120
//
// simple.vert
//
attribute vec3 position, velocity;
uniform mat4 transformMatrix;
uniform float gravity;
uniform sampler2D nmap, dmap;
varying vec3 pos, vel;
const float tstep = 1.0;
 
void main(void)
{
  gl_Position = transformMatrix * vec4(position, 1.0);
  vel = velocity + vec3(0.0, gravity, 0.0) * tstep;     // xɉx~Ԃ
  pos = position + vel * tstep;                         // _̈ʒuړ
  if (pos.y < -1.0) {                                   // _͈͊Oɏo
    pos.xz = fract(pos.xz * 0.5 + 0.5) * 2.0 - 1.0;
    pos.y += 2.0;                                       // ʒu𔽑Αɖ߂
    vel = vec3(0.0, 0.0, 0.0);                          // x 0 ɂ
  }
  else {
    vec3 p = pos.xyz * 0.5 + 0.5;
    if (p.y < texture2D(dmap, p.xz).y) {
      vel = reflect(vel, texture2D(nmap, p.xz).xyz);
    }
  }
}
